10 REM *** Intel-HEX TO EPROM Programmer File Conversion Program Version 1.00
20 REM *** Copyright (C) Paul Stenning and ETI, 1992.
30 REM
40 SCREEN 0 : CLS
50 DIM DAT$(15)
60 PRINT "Intel-HEX to Programmer File Conversion  -  (C) Paul Stenning & ETI, 1992"
70 PRINT : INPUT "Intel-HEX File Name  "; INTFILE$
80 PRINT : INPUT "Programmer File Name "; PRGFILE$
90 PRINT
100 PRINT "   1 - 2716"
110 PRINT "   2 - 2732"
120 PRINT "   3 - 2764"
130 PRINT "   4 - 27128"
140 PRINT "   5 - 27256"
150 PRINT "   6 - 27512"
160 PRINT "Select EPROM Type: ";
170 K$ = INKEY$
180 IF K$ = CHR$(27) THEN PRINT "Quit": GOTO 780
190 IF K$ = "1" THEN TYPENAME$ = "2716" : MAXADDR = 2047 : GOTO 260
200 IF K$ = "2" THEN TYPENAME$ = "2732" : MAXADDR = 4095 : GOTO 260
210 IF K$ = "3" THEN TYPENAME$ = "2764" : MAXADDR = 8191 : GOTO 260
220 IF K$ = "4" THEN TYPENAME$ = "27128" : MAXADDR = 16383 : GOTO 260
230 IF K$ = "5" THEN TYPENAME$ = "27256" : MAXADDR = 32767 : GOTO 260
240 IF K$ = "6" THEN TYPENAME$ = "27512" : MAXADDR = 65535 : GOTO 260
250 GOTO 170
260 PRINT TYPENAME$
270 OPEN INTFILE$ FOR INPUT AS #1
280 OPEN PRGFILE$ FOR OUTPUT AS #2
290 PRINT #2, TYPENAME$
300 PRINT
310 ADDR = 0
320 DAT% = 0
330 LINE INPUT #1, INTEL$
340 IF LEFT$(INTEL$, 1) <> ":" THEN BEEP : PRINT : PRINT "FILE NOT INTEL-HEX" : GOTO 780
350 SUM% = 0
360 ITEM% = VAL("&h" + MID$(INTEL$, 2, 2))
370 FOR COUNT = 2 TO (ITEM% * 2) + 8 STEP 2
380     SUM% = SUM% + VAL("&h" + MID$(INTEL$, COUNT, 2))
390     NEXT
400 SUM% = (256 - (SUM% AND 255)) AND 255
410 SUM$ = HEX$(SUM%)
420 IF LEN(SUM$) = 1 THEN SUM$ = "0" + SUM$
430 IF RIGHT$(INTEL$, 2) <> SUM$ THEN BEEP : PRINT : PRINT "CHECKSUM ERROR" : GOTO 780
440 IF MID$(INTEL$, 8, 2) = "01" THEN GOTO 570
450 IF MID$(INTEL$, 8, 2) <> "00" THEN BEEP : PRINT : PRINT "FILE ERROR" : GOTO 780
460 IF VAL("&h" + MID$(INTEL$, 4, 4)) <> ADDR THEN BEEP : PRINT : PRINT "ADDRESS ERROR" : GOTO 780
470 FOR COUNT = 0 TO ITEM% - 1
480     LOCATE CSRLIN, 1
490     PRINT "Converting Location"; ADDR + COUNT; "of"; MAXADDR;
500     DAT$(DAT%) = MID$(INTEL$, (COUNT * 2) + 10, 2)
510     DAT% = DAT% + 1
520     IF DAT% = 16 THEN GOSUB 670
530     IF ADDR + COUNT = MAXADDR THEN GOTO 760
540     NEXT
550 ADDR = ADDR + ITEM%
560 GOTO 320
570 LOCATE CSRLIN, 1
580 PRINT "End of Intel-HEX File Reached - Filling Programmer File with FF"
590 FOR COUNT = ADDR TO MAXADDR
600     LOCATE CSRLIN, 1
610     PRINT "Filling Location"; COUNT; "of"; MAXADDR;
620     DAT$(DAT%) = "FF"
630     DAT% = DAT% + 1
640     IF DAT% = 16 THEN GOSUB 670
650     NEXT
660 GOTO 760
670 ADDR$ = HEX$(ADDR + COUNT - 15)
680 IF LEN(ADDR$) < 4 THEN ADDR$ = "0" + ADDR$ : GOTO 680
690 PRINT #2, ADDR$; TAB(9);
700 FOR DAT% = 0 TO 15
710     PRINT #2, DAT$(DAT%); " ";
720     NEXT
730 PRINT #2,
740 DAT% = 0
750 RETURN
760 PRINT : PRINT
770 PRINT "Conversion Completed"
780 CLOSE : PRINT
790 END
