10 REM *** EPROM Programmer to Intel-HEX File Conversion Program Version 1.00
20 REM *** Copyright (C) Paul Stenning and ETI, 1992.
30 REM
40 SCREEN 0 : CLS
50 PRINT "Programmer to Intel-HEX File Conversion  -  (C) Paul Stenning & ETI, 1992"
60 PRINT : INPUT "Programmer File Name "; PRGFILE$
70 PRINT : INPUT "Intel-HEX File Name  "; INTFILE$
80 OPEN PRGFILE$ FOR INPUT AS #1
90 OPEN INTFILE$ FOR OUTPUT AS #2
100 LINE INPUT #1, DAT$
110 IF DAT$ = "2716" THEN MAXADDR = 2047 : GOTO 180
120 IF DAT$ = "2732" THEN MAXADDR = 4095 : GOTO 180
130 IF DAT$ = "2764" THEN MAXADDR = 8191 : GOTO 180
140 IF DAT$ = "27128" THEN MAXADDR = 16383 : GOTO 180
150 IF DAT$ = "27256" THEN MAXADDR = 32767 : GOTO 180
160 IF DAT$ = "27512" THEN MAXADDR = 65535 : GOTO 180
170 BEEP : PRINT "INPUT FILE ERROR" : GOTO 440
180 PRINT : PRINT "EPROM Type "; DAT$
190 PRINT
200 FOR ADDR = 0 TO (MAXADDR - 15) STEP 16
210     LINE INPUT #1, DAT$
220     DAT = VAL("&h" + LEFT$(DAT$, 4))
230     IF DAT < 0 THEN DAT = DAT + 65536
240     IF DAT <> ADDR THEN BEEP : PRINT : PRINT "FILE ADDRESS ERROR" : GOTO 440
250     INTEL$ = ":10" + LEFT$(DAT$, 4) + "00"
260     FOR COUNT% = 0 TO 15
270         LOCATE CSRLIN, 1
280         PRINT "Converting Location"; ADDR + COUNT%; "of"; MAXADDR;
290         INTEL$ = INTEL$ + MID$(DAT$, 9 + COUNT% * 3, 2)
300         NEXT
310     SUM% = 0
320     FOR COUNT% = 2 TO 40 STEP 2
330         SUM% = SUM% + VAL("&h" + MID$(INTEL$, COUNT%, 2))
340         NEXT
350     SUM% = (256 - (SUM% AND 255)) AND 255
360     SUM$ = HEX$(SUM%)
370     IF LEN(SUM$) = 1 THEN SUM$ = "0" + SUM$
380     INTEL$ = INTEL$ + SUM$
390     PRINT #2, INTEL$
400     NEXT
410 PRINT #2, ":00000001FF"
420 PRINT : PRINT
430 PRINT "Conversion Completed"
440 CLOSE : PRINT
450 END
