10 REM *** EPROM Programmer Compiled Test Program 2 Version 1.00
20 REM *** Copyright (C) Paul Stenning and ETI, 1992.
30 REM
40 SCREEN 0: CLS
50 PRINT "EPROM Programmer Test Program 2  -  (C) Paul Stenning & ETI, 1992"
60 PRINT
61 INPUT ; "Which Serial Port (1-4) "; p$
62 IF LEN(p$) <> 1 THEN BEEP: PRINT "    INVALID INPUT": GOTO 61
63 IF VAL(p$) < 1 OR VAL(p$) > 4 THEN BEEP: PRINT "    INVALID INPUT": GOTO 61
64 ON ERROR GOTO 500
70 OPEN "COM" + p$ + ":9600,N,8,1,CS200,CD0,DS0" FOR RANDOM AS #1 LEN = 1
72 PRINT "    ok": PRINT : PRINT
74 ON ERROR GOTO 600
80 PRINT #1, CHR$(VAL("&h20"));
90 PRINT #1, CHR$(VAL("&h31"));
100 PRINT #1, CHR$(VAL("&h40"));
110 FOR COUNT = 0 TO 65535
120 LOCATE CSRLIN, 1: PRINT "Count ="; COUNT;
130 IF COUNT = 0 THEN GOSUB 210
140 IF COUNT = 21845 THEN GOSUB 210
150 IF COUNT = 43690 THEN GOSUB 210
160 IF COUNT = 65535 THEN GOSUB 210
170 PRINT #1, CHR$(VAL("&h50"));
180 IF INKEY$ = CHR$(27) THEN PRINT TAB(18); "*** ABORTED ***": GOTO 200
190 NEXT
200 PRINT : CLOSE #1: END
210 PRINT TAB(18); "Paused - Press Any Key to Continue..."
215 X$ = INKEY$
220 IF X$ = "" THEN GOTO 215
225 IF X$ = CHR$(27) THEN PRINT TAB(18); "ABORTED": GOTO 200
230 RETURN

500 CLOSE
510 PRINT : PRINT : PRINT
520 PRINT "ERROR OPENING COM"; p$; "  -  PROGRAM TERMINATED!"
530 PRINT : END

600 CLOSE
620 PRINT "ERROR COMMUNICATING THROUGH COM"; p$; "  -  PROGRAM TERMINATED!"
630 PRINT : END

