DECLARE FUNCTION GetText$ (Text$, Length%, UpCase%)
DECLARE FUNCTION GetKey$ ()



'Last Modified on 13/12/92 - Revision 4


IF COMMAND$ = "" THEN CLS
PRINT : PRINT : PRINT
PRINT "EPROM Programmer Software Registration  -  (C) Paul Stenning, 1992."
PRINT
PRINT "Enter Users Name >";
A$ = GetText$("", 37, 0)
IF A$ = "" THEN END
FOR x% = 1 TO LEN(A$)
y& = y& + ASC(MID$(A$, x%, 1)) * x%
NEXT
y& = ((y& * 297) + 1964)
B$ = STR$(y&)
B$ = RIGHT$(B$, LEN(B$) - 1)
B$ = RIGHT$(B$, LEN(B$) - 4) + LEFT$(B$, 4)
PRINT : PRINT B$
PRINT : PRINT "Writing Registration File ... ";
ON ERROR GOTO KillError
KILL COMMAND$ + "EPROM.REG"
ON ERROR GOTO 0
OPEN COMMAND$ + "EPROM.REG" FOR OUTPUT AS #2
PRINT #2, "EPROM Programmer Registration File"
PRINT #2, A$
PRINT #2, B$
PRINT #2, CHR$(26)
CLOSE #2
IF COMMAND$ <> "" THEN
	OPEN "EPROM.LST" FOR APPEND AS #2
	PRINT #2, A$; TAB(40); B$
	CLOSE #2
END IF
PRINT "Done.": PRINT
END

KillError:
RESUME NEXT

FileError:
PRINT : PRINT "ERROR WRITING REGISTRATION FILE - PROGRAM TERMINATED"
CLOSE
END

'**************************** End of Main Code ****************************

FUNCTION GetKey$
x$ = INKEY$
IF x$ = "" THEN
	GetKey$ = ""
	EXIT FUNCTION
END IF
IF LEN(x$) = 2 THEN
	SELECT CASE ASC(RIGHT$(x$, 1))
		CASE 15: x$ = "TAB-SHIFT"
		CASE 59: x$ = "F1"
		CASE 60: x$ = "F2"
		CASE 61: x$ = "F3"
		CASE 62: x$ = "F4"
		CASE 63: x$ = "F5"
		CASE 64: x$ = "F6"
		CASE 65: x$ = "F7"
		CASE 66: x$ = "F8"
		CASE 67: x$ = "F9"
		CASE 68: x$ = "F10"
		CASE 71: x$ = "HOME"
		CASE 72: x$ = "UP"
		CASE 73: x$ = "PGUP"
		CASE 75: x$ = "LEFT"
		CASE 77: x$ = "RIGHT"
		CASE 79: x$ = "END"
		CASE 80: x$ = "DOWN"
		CASE 81: x$ = "PGDN"
		CASE 82: x$ = "INS"
		CASE 83: x$ = "DEL"
		CASE 84: x$ = "F1-SHIFT"
		CASE 85: x$ = "F2-SHIFT"
		CASE 86: x$ = "F3-SHIFT"
		CASE 87: x$ = "F4-SHIFT"
		CASE 88: x$ = "F5-SHIFT"
		CASE 89: x$ = "F6-SHIFT"
		CASE 90: x$ = "F7-SHIFT"
		CASE 91: x$ = "F8-SHIFT"
		CASE 92: x$ = "F9-SHIFT"
		CASE 93: x$ = "F10-SHIFT"
		CASE 94: x$ = "F1-CTRL"
		CASE 95: x$ = "F2-CTRL"
		CASE 96: x$ = "F3-CTRL"
		CASE 97: x$ = "F4-CTRL"
		CASE 98: x$ = "F5-CTRL"
		CASE 99: x$ = "F6-CTRL"
		CASE 100: x$ = "F7-CTRL"
		CASE 101: x$ = "F8-CTRL"
		CASE 102: x$ = "F9-CTRL"
		CASE 103: x$ = "F10-CTRL"
		CASE 115: x$ = "LEFT-CTRL"
		CASE 116: x$ = "RIGHT-CTRL"
		CASE 117: x$ = "END-CTRL"
		CASE 118: x$ = "PGDN-CTRL"
		CASE 119: x$ = "HOME-CTRL"
		CASE 132: x$ = "PGUP-CTRL"
		CASE 133: x$ = "F11"
		CASE 134: x$ = "F12"
		CASE 135: x$ = "F11-SHIFT"
		CASE 136: x$ = "F12-SHIFT"
		CASE 137: x$ = "F11-CTRL"
		CASE 138: x$ = "F12-CTRL"
		CASE ELSE: x$ = ""
	   'CASE ELSE: x$ = STR$(ASC(RIGHT$(x$, 1)))
	END SELECT
ELSE
	SELECT CASE ASC(x$)
		CASE 8: x$ = "BS"
		CASE 9: x$ = "TAB"
		CASE 13: x$ = "CR"
		CASE 27: x$ = "ESC"
	END SELECT
END IF
GetKey$ = x$

END FUNCTION

FUNCTION GetText$ (Text$, Length%, UpCase%)
AutoEnd% = 0
Row% = CSRLIN: Column% = POS(0): CP% = LEN(Text$)
Ins% = 0
IF UpCase% = 1 THEN Text$ = UCASE$(Text$)
DO WHILE -1
	LOCATE Row%, Column%, 0: PRINT Text$; '  " ";
	LOCATE Row%, Column% + CP%, 1
	IF AutoEnd% AND (LEN(Text$) = Length%) THEN
		GetText$ = Text$
		LOCATE , , 1, 7, 8
		EXIT FUNCTION
	END IF
	DO
		x$ = GetKey$
	LOOP UNTIL x$ <> ""
	IF UpCase% = 1 THEN x$ = UCASE$(x$)
	IF LEN(x$) = 1 THEN
		IF CP% >= LEN(Text$) THEN
			IF LEN(Text$) < Length% THEN
				Text$ = Text$ + x$
				CP% = CP% + 1
			END IF
		ELSE
			CP% = CP% + 1
			IF Ins% = 0 THEN
				MID$(Text$, CP%) = x$
			ELSE
				Text$ = LEFT$(Text$, CP% - 1) + x$ + RIGHT$(Text$, LEN(Text$) - CP% + 1)
				Text$ = LEFT$(Text$, Length%)
			END IF
		END IF
	ELSE
		SELECT CASE x$
			CASE "INS"
				IF Dates% THEN Ins% = 1
				IF Ins% = 0 THEN
					Ins% = 1: LOCATE , , , 4, 8
				ELSE
					Ins% = 0: LOCATE , , , 7, 8
				END IF
			CASE "BS"
				IF CP% > 0 THEN
					CP% = CP% - 1
					IF CP% + 1 = LEN(Text$) THEN
						Text$ = LEFT$(Text$, CP%)
					ELSE
						Text$ = LEFT$(Text$, CP%) + RIGHT$(Text$, LEN(Text$) - CP% - 1)
					END IF
					LOCATE Row%, Column% + LEN(Text$), 0
					PRINT " ";
				END IF
			CASE "DEL"
				IF CP% >= 0 AND CP% < LEN(Text$) THEN
					Text$ = LEFT$(Text$, CP%) + RIGHT$(Text$, LEN(Text$) - CP% - 1)
					LOCATE Row%, Column% + LEN(Text$), 0
					PRINT " ";
				END IF
			CASE "LEFT"
				IF CP% > 0 THEN
					CP% = CP% - 1
					END IF
			CASE "RIGHT"
				IF CP% < LEN(Text$) THEN
					CP% = CP% + 1
				END IF
			CASE "HOME"
				CP% = 0
			CASE "END"
				CP% = LEN(Text$)
			CASE "ESC"
				GetText$ = ""
				LOCATE , , 1, 7, 8
				EXIT FUNCTION
			CASE "CR"
				GetText$ = Text$
				LOCATE , , 1, 7, 8
				EXIT FUNCTION
		END SELECT
	END IF
LOOP
END FUNCTION

