10 REM *** EPROM Programmer BASICA Control Software Version 1.00
20 REM *** Copyright (C) Paul Stenning and ETI, 1992.
30 REM
40 SCREEN 0 : CLS
50 PRINT "EPROM Programmer BASICA Control Software  -  (C) Paul Stenning & ETI, 1992"
60 PRINT : PRINT "Ensure EPROM Socket is Empty, then press any key..."
70 K$ = INKEY$ : IF K$ = "" THEN GOTO 70
80 IF K$ = CHR$(27) THEN PRINT : PRINT "Quit" : GOTO 10000
90 PRINT "Establishing Communication ";
100 OPEN "COM1:9600,N,8,1,CS200,CD0,DS0" FOR RANDOM AS #1 LEN = 1
110 PRINT ". ";
120 S$ = "30" : GOSUB 8000 : S$ = "60" : GOSUB 8000 : S$ = "70" : GOSUB 8000 : GOSUB 7000
130 IF F$ = "**" THEN PAUSE% = 1 ELSE PAUSE% = 0
140 PRINT ". ";
150 S$ = "05" : GOSUB 8000 : S$ = "15" : GOSUB 8000 : S$ = "60" : GOSUB 8000
160 IF PAUSE% = 0 THEN GOTO 190
170 TIME = TIMER + 0.1
180 IF TIMER < TIME GOTO 180
190 S$ = "70" : GOSUB 8000
200 GOSUB 7000
210 IF F$ <> "55" THEN GOTO 9000
220 PRINT ". ";
230 S$ = "0A" : GOSUB 8000 : S$ = "1A" : GOSUB 8000 : S$ = "60" : GOSUB 8000
240 IF PAUSE% = 0 THEN GOTO 270
250 TIME = TIMER + 0.1
260 IF TIMER < TIME GOTO 260
270 S$ = "70" : GOSUB 8000 : GOSUB 7000
280 IF F$ <> "AA" THEN GOTO 9000
290 PRINT ". ";
300 IF PAUSE% = 0 THEN PRINT "Ok." ELSE PRINT "No CTS Line - Software Delay Used."
310 PRINT
320 PRINT "   1 - 2716"
330 PRINT "   2 - 2732"
340 PRINT "   3 - 2764"
350 PRINT "   4 - 27128"
360 PRINT "   5 - 27256"
370 PRINT "   6 - 27512"
380 PRINT "Select EPROM Type: ";
390 K$ = INKEY$
400 IF K$ = CHR$(27) THEN PRINT "Quit" : GOTO 10000
410 IF K$ = "1" THEN TYPENAME$ = "2716" : TYPECODE$ = "2F" : MAXADDR = 2047 : GOTO 480
420 IF K$ = "2" THEN TYPENAME$ = "2732" : TYPECODE$ = "25" : MAXADDR = 4095 : GOTO 480
430 IF K$ = "3" THEN TYPENAME$ = "2764" : TYPECODE$ = "23" : MAXADDR = 8191 : GOTO 480
440 IF K$ = "4" THEN TYPENAME$ = "27128" : TYPECODE$ = "23" : MAXADDR = 16383 : GOTO 480
450 IF K$ = "5" THEN TYPENAME$ = "27256" : TYPECODE$ = "21" : MAXADDR = 32767 : GOTO 480
460 IF K$ = "6" THEN TYPENAME$ = "27512" : TYPECODE$ = "20" : MAXADDR = 65535 : GOTO 480
470 GOTO 390
480 PRINT TYPENAME$
490 PRINT
500 PRINT "   1 - 12.5 Volts"
510 PRINT "   2 - 21/25 Volts"
520 PRINT "Select EPROM Programming Voltage: ";
530 K$ = INKEY$
540 IF K$ = CHR$(27) THEN PRINT "Quit" : GOTO 10000
550 IF K$ = "1" THEN PROGVOLTNAME$ = "12.5 Volts" : STATUS% = 4 : GOTO 580
560 IF K$ = "2" THEN PROGVOLTNAME$ = "21/25 Volts" : STATUS% = 0 : GOTO 580
570 GOTO 530
580 PRINT PROGVOLTNAME$
590 PRINT
600 PRINT "   1 - 5 Volts"
610 PRINT "   2 - 6 Volts"
620 PRINT "Select EPROM Supply Voltage: ";
630 K$ = INKEY$
640 IF K$ = CHR$(27) THEN PRINT "Quit" : GOTO 10000
650 IF K$ = "1" THEN SUPPVOLTNAME$ = "5 Volts" : STATUS% = STATUS% + 8 : GOTO 680
660 IF K$ = "2" THEN SUPPVOLTNAME$ = "6 Volts" : STATUS% = STATUS% + 0 : GOTO 680
670 GOTO 630
680 PRINT SUPPVOLTNAME$
690 PRINT
700 PRINT "   1 - 1 MilliSecond"
710 PRINT "   2 - 40 MilliSeconds"
720 PRINT "Select EPROM Program Pulse Duration: ";
730 K$ = INKEY$
740 IF K$ = CHR$(27) THEN PRINT "Quit" : GOTO 10000
750 IF K$ = "1" THEN PROGPULSENAME$ = "1 MilliSecond" : STATUS% = STATUS% + 2 : GOTO 780
760 IF K$ = "2" THEN PROGPULSENAME$ = "40 MilliSeconds" : STATUS% = STATUS% + 0 : GOTO 780
770 GOTO 730
780 PRINT PROGPULSENAME$;
790 S$ = TYPECODE$ : GOSUB 8000
800 S$ = "3" + HEX$(STATUS% + 1) : GOSUB 8000
810 S$ = "00" : GOSUB 8000 : S$ = "10" : GOSUB 8000
820 S$ = "40" : GOSUB 8000 : S$ = "80" : GOSUB 8000

1000 REM *** Main Menu
1010 CLS
1020 PRINT "EPROM Programmer BASICA Control Software  -  (C) Paul Stenning & ETI, 1992"
1030 PRINT "Type "; TYPENAME$; "   Program "; PROGVOLTNAME$; 
1040 PRINT "   Supply "; SUPPVOLTNAME$; "   Pulse "; PROGPULSENAME$
1050 PRINT : PRINT "MAIN MENU"
1060 PRINT "~~~~~~~~~"
1070 PRINT "   1 - Read"
1080 PRINT "   2 - Program"
1090 PRINT "   3 - Verify"
1100 PRINT "   4 - Blank Check"
1110 PRINT "   5 - Change Configuration"
1120 PRINT "   6 - Adjust Voltages"
1130 PRINT " ESC - Quit"
1140 PRINT : PRINT "Select Option Required: ";
1150 K$ = INKEY$
1160 IF K$ = "1" THEN PRINT "Read" : GOTO 2000
1170 IF K$ = "2" THEN PRINT "Program" : GOTO 3000
1180 IF K$ = "3" THEN PRINT "Verify" : GOTO 4000
1190 IF K$ = "4" THEN PRINT "Blank Check" : GOTO 5000
1200 IF K$ = "5" THEN RUN
1210 IF K$ = "6" THEN PRINT "Adjust Voltages" : GOTO 6000
1220 IF K$ = CHR$(27) THEN PRINT "Quit" : GOTO 10000
1230 GOTO 1150

2000 REM *** Read EPROM to File
2010 PRINT : PRINT "Insert EPROM to Read, then press any key (ESC to Abort)"
2020 K$ = INKEY$ : IF K$ = "" THEN GOTO 2020
2030 IF K$ = CHR$(27) THEN GOTO 1000
2040 PRINT
2050 INPUT "Output File Name "; FILE$
2060 OPEN FILE$ FOR OUTPUT AS #2
2070 PRINT
2080 PRINT #2, TYPENAME$
2090 S$ = "40" : GOSUB 8000
2100 TIME = TIMER + 0.25
2110 IF TIMER < TIME THEN GOTO 2110
2120 FOR ADDR = 0 TO (MAXADDR - 15) STEP 16
2130     IF INKEY$ = CHR$(27) THEN BEEP : PRINT : PRINT "ABORTED!" : GOTO 2260
2140     ADDR$ = HEX$(ADDR)
2150     IF LEN(ADDR$) < 4 THEN ADDR$ = "0" + ADDR$ : GOTO 2150
2160     PRINT #2, ADDR$; TAB(9);
2170     FOR COUNT% = 0 TO 15
2180         S$ = "70" : GOSUB 8000 : GOSUB 7000
2190         PRINT #2, F$; " ";
2200         S$ = "50" : GOSUB 8000
2210         LOCATE CSRLIN, 1
2220         PRINT "Reading Location"; ADDR + COUNT%; "of"; MAXADDR;
2230         NEXT
2240     PRINT #2,
2250     NEXT
2260 S$ = "40" : GOSUB 8000 : S$ = "80" : GOSUB 8000
2270 CLOSE #2
2280 PRINT : PRINT "Press any key to continue...";
2290 IF INKEY$ = "" THEN GOTO 2290
2300 GOTO 1000

3000 REM *** Program EPROM from File
3010 PRINT
3020 PRINT "Insert EPROM to Program, then press any key (ESC to Abort)"
3030 K$ = INKEY$ : IF K$ = "" THEN GOTO 3030
3040 IF K$ = CHR$(27) THEN GOTO 1000
3050 PRINT
3060 INPUT "Input File Name ";FILE$
3070 OPEN FILE$ FOR INPUT AS #2
3080 LINE INPUT #2, DAT$
3090 IF DAT$ <> TYPENAME$ THEN : BEEP : PRINT "FILE DOES NOT MATCH EPROM TYPE" : GOTO 3340
3100 S$ = "3" + HEX$(STATUS%): GOSUB 8000
3110 S$ = "40" : GOSUB 8000
3120 TIME = TIMER + 0.25
3130 IF TIMER < TIME THEN GOTO 3130
3140 PRINT
3150 FOR ADDR = 0 TO (MAXADDR - 15) STEP 16
3160     IF INKEY$ = CHR$(27) THEN BEEP : PRINT : PRINT "ABORTED!" : GOTO 3340
3170     LINE INPUT #2, DAT$
3180     DAT = VAL("&h" + LEFT$(DAT$, 4))
3190     IF DAT < 0 THEN DAT = DAT + 65536
3200     IF DAT <> ADDR THEN BEEP : PRINT : PRINT "FILE ADDRESS ERROR" : GOTO 3340
3210     FOR COUNT% = 0 TO 15
3220         LOCATE CSRLIN, 1
3230         PRINT "Programming Location"; ADDR + COUNT%; "of"; MAXADDR;
3240         S$ = "0" + MID$(DAT$, 10 + COUNT% * 3, 1) : GOSUB 8000
3250         S$ = "1" + MID$(DAT$, 9 + COUNT% * 3, 1) : GOSUB 8000
3260         S$ = "60" : GOSUB 8000
3270         IF PAUSE% = 0 THEN GOTO 3300
3280         TIME = TIMER + 0.1
3290         IF TIMER < TIME THEN GOTO 3290
3300         S$ = "50" : GOSUB 8000
3310         NEXT
3320     NEXT
3330 PRINT
3340 S$ = "3" + HEX$(STATUS% + 1) : GOSUB 8000
3350 S$ = "40" : GOSUB 8000 : S$ = "80" : GOSUB 8000
3360 CLOSE #2
3370 PRINT : PRINT "Press any key to continue...";
3380 IF INKEY$ = "" THEN GOTO 3380
3390 GOTO 1000

4000 REM *** Verify EPROM with File
4010 PRINT : PRINT "Insert EPROM to Verify, then press any key (ESC to Abort)"
4020 K$ = INKEY$ : IF K$ = "" THEN GOTO 4020
4030 IF K$ = CHR$(27) THEN GOTO 1000
4040 PRINT : INPUT "Input File Name "; FILE$
4050 OPEN FILE$ FOR INPUT AS #2
4060 PRINT
4070 LINE INPUT #2, DAT$
4080 IF DAT$ <> TYPENAME$ THEN BEEP : PRINT "FILE DOES NOT MATCH EPROM TYPE" : GOTO 4300
4090 S$ = "40" : GOSUB 8000
4100 TIME = TIMER + 0.25
4110 IF TIMER < TIME THEN GOTO 4110
4120 FAIL = 0
4130 FOR ADDR = 0 TO (MAXADDR - 15) STEP 16
4140     IF INKEY$ = CHR$(27) THEN BEEP : PRINT : PRINT "ABORTED!" : GOTO 4300
4150     LINE INPUT #2, DAT$
4160     DAT = VAL("&h" + LEFT$(DAT$, 4))
4170     IF DAT < 0 THEN DAT = DAT + 65536
4180     IF DAT <> ADDR THEN BEEP : PRINT : PRINT "FILE ADDRESS ERROR" : GOTO 4300
4190     FOR COUNT% = 0 TO 15
4200         LOCATE CSRLIN, 1
4210         PRINT "Verifying Location"; ADDR + COUNT%; "of"; MAXADDR;
4220         S$ = "70" : GOSUB 8000 : GOSUB 7000
4230         IF F$ <> (MID$(DAT$, 9 + COUNT% * 3, 2)) THEN FAIL = FAIL + 1
4240         S$ = "50" : GOSUB 8000
4250         NEXT
4260     NEXT
4270 PRINT : PRINT
4280 IF FAIL = 0 THEN PRINT "Verified Ok"
4290 IF FAIL <> 0 THEN BEEP : PRINT "Verify Failed on"; FAIL; "Locations"
4300 S$ = "40" : GOSUB 8000 : S$ = "80" : GOSUB 8000
4310 CLOSE #2 : PRINT : PRINT "Press any key to continue...";
4320 IF INKEY$ = "" THEN GOTO 4320
4330 GOTO 1000

5000 REM *** Blank Check EPROM
5010 PRINT : PRINT "Insert EPROM to Blank Check, then press any key (ESC to Abort)"
5020 K$ = INKEY$ : IF K$ = "" THEN GOTO 5020
5030 IF K$ = CHR$(27) THEN GOTO 1000
5040 PRINT
5050 S$ = "40" : GOSUB 8000
5060 TIME = TIMER + 0.25
5070 IF TIMER < TIME THEN GOTO 5070
5080 FAIL = 0
5090 FOR ADDR = 0 TO MAXADDR
5100     LOCATE CSRLIN, 1
5110     PRINT "Checking Location"; ADDR; "of"; MAXADDR;
5120     S$ = "70" : GOSUB 8000
5130     GOSUB 7000
5140     IF F$ <> "FF" THEN FAIL = FAIL + 1
5150     S$ = "50" : GOSUB 8000
5160     IF INKEY$ = CHR$(27) THEN BEEP : PRINT : PRINT "ABORTED!" : GOTO 5210
5170     NEXT
5180 PRINT : PRINT
5190 IF FAIL = 0 THEN PRINT "Blank EPROM"
5200 IF FAIL <> 0 THEN BEEP : PRINT "EPROM NOT BLANK - Failed on"; FAIL; "Locations"
5210 S$ = "40" : GOSUB 8000 : S$ = "80" : GOSUB 8000
5220 PRINT : PRINT "Press any key to continue...";
5230 IF INKEY$ = "" THEN GOTO 5230
5240 GOTO 1000

6000 REM *** Adjust Programming Voltages
6010 PRINT : PRINT "Ensure EPROM Socket is Empty, then press any key (ESC to Abort)"
6020 K$ = INKEY$ : IF K$ = "" THEN GOTO 6020
6030 IF K$ = CHR$(27) THEN GOTO 1000
6040 PRINT
6050 S$ = "20" : GOSUB 8000 : S$ = "30" : GOSUB 8000
6060 PRINT "Connect Test Meter Between pins 28 (+ve) and 14 (-ve) of EPROM Socket"
6070 PRINT "Adjust RV1 for Reading of 6.1V  (+/- 0.1V), then press any key..."
6080 IF INKEY$ = "" THEN GOTO 6080
6090 PRINT
6100 S$ = "21" : GOSUB 8000 : S$ = "34" : GOSUB 8000
6110 PRINT "Connect Test Meter Between pins 1 (+ve) and 14 (-ve) of EPROM Socket"
6120 PRINT "Adjust RV2 for Reading of 12.6V (+/- 0.1V), then press any key..."
6130 IF INKEY$ = "" THEN GOTO 6130
6140 S$ = "30" : GOSUB 8000
6150 PRINT "Adjust RV3 for Reading of 21V  (+/- 0.25V), then press any key..."
6160 IF INKEY$ = "" THEN GOTO 6160
6170 S$ = "2F" : GOSUB 8000
6180 PRINT "Adjust RV4 for Reading of 25V  (+/- 0.25V), then press any key...";
6190 IF INKEY$ = "" THEN GOTO 6190
6200 S$ = TYPECODE$ : GOSUB 8000 : S$ = "3" + HEX$(STATUS% + 1) : GOSUB 8000
6210 S$ = "80" : GOSUB 8000
6220 GOTO 1000

7000 REM *** Fetch Byte from Programmer
7010 TIMEOUT = TIMER + 0.1
7020 IF EOF(1) AND TIMER < TIMEOUT THEN GOTO 7020
7030 IF TIMER >= TIMEOUT THEN F$ = "**" : RETURN
7040 F$ = HEX$(ASC(INPUT$(1, #1)))
7050 IF LEN(F$) < 2 THEN F$ = "0" + F$
7060 RETURN

8000 REM *** Send Byte to Programmer
8010 PRINT #1, CHR$(VAL("&h" + S$));
8020 RETURN

9000 REM *** Communication Error Message
9010 PRINT ". ERROR COMMUNICATING WITH PROGRAMMER"
9020 BEEP
9030 GOTO 10000

10000 REM *** End Program
10010 CLOSE 
10020 PRINT : PRINT
10030 SYSTEM
